package scripts.migration.from4_4To4_5.form;

import scripts.migration.from4_4To4_5.util.MigrationUtil;
import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.HierarchyManager;
import info.magnolia.context.Context;

/**
 * The goal of this step is to do the extra tasks of Form.
 * The main thing to do is to transform the component: form ,formGroupFields, formGroupEdit and formSubmit.
 *
 */
class ExtraFormTasks {

  Context ctx
  HierarchyManager hm
  String workspace

  Content formComponents
  Map componentsIdMap

  def transformForm(){
	if(formComponents.hasContent("form")) {
		Content form = formComponents.getContent("form")
		if(!form.hasContent("areas")){
			// this list if the available components of formGroupFields
			form.delete("paragraphs")
			// create the 'areas' node
			Content areas = MigrationUtil.createAreasNode(form)
			def availableComponents =
			[
			"formGroupFields"
			]
			String templateScript = "/form/generic/listArea.ftl"
			MigrationUtil.createArea(areas, "fieldsets", templateScript, "list", true, null, null, availableComponents, null, componentsIdMap)
		}
	}
  }

  def transformFormSteps(){
	if(formComponents.hasContent("formStep")) {
	    Content form = formComponents.getContent("formStep")
	    if(!form.hasContent("areas")){
	      Content areas = MigrationUtil.createAreasNode(form)
	      def availableComponents = [
	        "formGroupFields"
	      ]
	      String templateScript = "/form/generic/listArea.ftl"
	      MigrationUtil.createArea(areas, "fieldsets", templateScript, "list", true, null, null, availableComponents, null, componentsIdMap)
	    }
	}
  }

  def transformFormGroupFields(){
	if(formComponents.hasContent("formGroupFields")) {
	    Content formGroupFields = formComponents.getContent("formGroupFields")
	    if(!formGroupFields.hasContent("areas")){
	      // create the 'areas' node
	      Content areas = MigrationUtil.createAreasNode(formGroupFields)
	      def availableComponents = [
	        "formEdit",
	        "formPassword",
	        "formHidden",
	        "formGroupEdit",
	        "formSelection",
	        "formFile",
	        "formSubmit",
	        "formCriteria",
	        "formSummary"
	      ]
	      String templateScript = "/form/generic/listArea.ftl"
	      MigrationUtil.createArea(areas, "fields", templateScript, "list", true, null, null, availableComponents, null, componentsIdMap)
	    }
	}
  }

  def transformFormGroupEdit(){
	if(formComponents.hasContent("formGroupEdit")){
	    Content component = formComponents.getContent("formGroupEdit")
	    if(!component.hasContent("areas")){
	      // create the 'areas' node
	      Content areas = MigrationUtil.createAreasNode(component)
	      def availableComponents = [
	        "formGroupEditItem"
	      ]
	      String templateScript = "/form/generic/listArea.ftl"
	      MigrationUtil.createArea(areas, "edits", templateScript, "list", true, null, null, availableComponents, null, componentsIdMap)
	    }
	}
  }

  def transformFormSubmit(){
	if(formComponents.hasContent("formSubmit")){
		Content component = formComponents.getContent("formSubmit")
	    if(!component.hasContent("areas")){
	      // create the 'areas' node
	      Content areas = MigrationUtil.createAreasNode(component)
	      def availableComponents = ["formCondition"]
	      String templateScript = "/form/components/conditionList.ftl";
	      MigrationUtil.createArea(areas, "conditionList", templateScript, "list", true, null, null, availableComponents, null, componentsIdMap)
	    }
	}
  }

  def execute(){
    if(MigrationUtil.moduleisInstalled("form")){
      hm = ctx.getHierarchyManager(workspace);
      formComponents = hm.getContent('/modules/form/templates/components')
      transformForm()
      transformFormSteps()
      transformFormGroupFields()
      transformFormSubmit()
      transformFormGroupEdit()
    }
  }
}
