package scripts.migration.from4_4To4_5.general;

import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.HierarchyManager;
import info.magnolia.cms.core.NodeData;
import info.magnolia.cms.util.ContentUtil;
import info.magnolia.context.Context;

import org.apache.commons.lang.StringUtils;

import scripts.migration.from4_4To4_5.util.MigrationUtil;

class ChangeReferencesToExtends {

  Context ctx
  HierarchyManager hm
  String workspace

  def doModules(Collection modules){
    modules.each{ String moduleName ->
      doModule(moduleName)
    }
  }

  def doModule(String moduleName){
    changeReferencesToExtends(moduleName);
  }

  def changeReferencesToExtends(String moduleName) {
    String dialogsPath = "/modules/" + moduleName + "/dialogs"

    hm = ctx.getHierarchyManager(workspace)
    Content root = hm.getContent(dialogsPath)

    ContentUtil.collectAllChildren(root).each { Content rootChild ->
      rootChild.getNodeDataCollection('reference').each { referenceNodeData ->
        MigrationUtil.renameProperty(referenceNodeData, "extends")
      }
      //STK specific
      MigrationUtil.replaceSubstringInProperty(rootChild, 'extends', 'standard-templating-kit/dialogs/paragraphs', 'standard-templating-kit/dialogs/components')

      //Adapting any extends value to the new dialog paths/names.
      if(rootChild.hasNodeData("extends")){
          NodeData extendsProp = rootChild.getNodeData("extends");
          String origExtendsValue = extendsProp.getString();
          Map dialogsToRename = RenameDialogsAndChangeInDialogsMap.dialogsToRename();

          //Need to iterate and compare, for finding extends of subnodes of the changed dialog.
          dialogsToRename.each{String oldDialogPath, String newDialogName ->
              if(StringUtils.contains(origExtendsValue, oldDialogPath)){
                  String oldDialogName = StringUtils.substringAfterLast(oldDialogPath, "/")
                  String newExtendsValue = origExtendsValue.replace(oldDialogName, newDialogName)
                  rootChild.setNodeData("extends", newExtendsValue)
              }

          }
       }
     }
   }
}