package scripts.migration.from4_4To4_5.shop;

import scripts.migration.from4_4To4_5.util.MigrationUtil;
import info.magnolia.cms.core.Content;
import info.magnolia.cms.core.HierarchyManager;
import info.magnolia.context.Context;
import info.magnolia.cms.util.NodeDataUtil;

/**
 * The goal of this step is to do the extra tasks of Shop.
 * The main thing to do is to transform the component: shopForm, shopFormStepConfirmOrder.
 *
 */
class ExtraShopTasks {

  Context ctx
  HierarchyManager hm
  String workspace

  Content formComponents
  Map componentsIdMap

  def transformForm(){
	if(formComponents.hasContent("shopForm")) {
		Content form = formComponents.getContent("shopForm")
		if(!form.hasContent("areas")){
			// this list if the available components of formGroupFields
			form.delete("paragraphs")
			// create the 'areas' node
			Content areas = MigrationUtil.createAreasNode(form)
			def availableComponents =
			[
			"formGroupFields"
			]
			String templateScript = "/form/generic/listArea.ftl"
			MigrationUtil.createArea(areas, "fieldsets", templateScript, "list", true, null, null, availableComponents, null, componentsIdMap)
		}
	}
  }

  def transformFormSteps(){
	if(formComponents.hasContent("shopFormStepConfirmOrder")) {
	    Content form = formComponents.getContent("shopFormStepConfirmOrder")
	    if(!form.hasContent("areas")){
	      Content areas = MigrationUtil.createAreasNode(form)
	      def availableComponents = [
	        "formGroupFields"
	      ]
	      String templateScript = "/form/generic/listArea.ftl"
	      MigrationUtil.createArea(areas, "fieldsets", templateScript, "list", true, null, null, availableComponents, null, componentsIdMap)
	    }
	}
  }


  def execute(){
    if(MigrationUtil.moduleisInstalled("shop")){
      hm = ctx.getHierarchyManager(workspace);
      formComponents = hm.getContent('/modules/shop/templates/components/features')
      transformForm()
      transformFormSteps()
    }
  }
}
